/*
 *
 * Copyright (c) 2004  DMC Co., Ltd.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 * Except as contained in this notice, the name of the DMC Co., Ltd shall not 
 * be used in advertising or otherwise to promote the sale, use or other dealings
 * in this Software without prior written authorization from DMC Co., Ltd.
 */
/*
 * EUC
 * tab=4
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <sys/wait.h>
#include "tb.h"
#include "../driver/cmd.h"
#include "../vers.h"

#define	CALIB_SET_234569	0
#define ENABLE_POINT_MODE	1

int main(int argc,char *argv[]);
void prhelp();
void domain();

int run_exec(int snum,int cmd);
#define	CMD_TBCALIB		0
#define	CMD_TBTEST		1
#define	CMD_SELECTOR	2

int get_xy_at_dual(int snum,int *x,int *y,int *wx,int *wy);

int wVer(uWindowPtr par_w);
void wVer_draw_win(uWindowPtr win,int y);

int pid;
int fork_cur_dir = false;
int scr_vga = false;
int scr_dual = false;
uRect max_dat[MAX_SCREEN];
int snum = 0;
static Display *sDisp;

typedef struct uControlTable
{
	int type;
	int x,y,w,h;
	int grp;
	int state;
	char *s;
} uControlTable;

uControlTable ctltb0[] =
{
	{ PT_BUTTON , 256,   5,  64,  25,0,STATE_OFF   ,RELEASE_VERSION },
	{ PT_STEXT  ,   5,  25, 102,  25,0,STATE_LEFT  ,"< Sampling Rate >" },
	{ PT_RADIO  ,  25,  50,  62,  25,1,STATE_OFF   ,"30 p/s" },
	{ PT_RADIO  ,  25,  75,  62,  25,1,STATE_OFF   ,"50 p/s" },
	{ PT_RADIO  ,  25, 100,  62,  25,1,STATE_OFF   ,"80 p/s" },
	{ PT_RADIO  ,  25, 125,  62,  25,1,STATE_OFF   ,"100 p/s" },
	{ PT_RADIO  ,  25, 150,  62,  25,1,STATE_OFF   ,"130 p/s" },
	{ PT_RADIO  ,  25, 175,  62,  25,1,STATE_ON    ,"150 p/s" },
	{ PT_RADIO  ,  25, 200,  62,  25,1,STATE_OFF   ,"Point mode" },
	{ PT_STEXT  , 117,  25, 126,  25,0,STATE_LEFT  ,"      < Sound >      " },
	{ PT_CKBOX  , 116,  50, 126,  25,0,STATE_ON    ,"Touch Down Beep on" },
	{ PT_CKBOX  , 116,  75, 126,  25,0,STATE_ON    ,"Touch Up Beep on" },
	{ PT_BUTTON ,   5, 225, 155,  25,0,STATE_OFF   ,"Apply" },
	{ PT_BUTTON , 170, 225, 155,  25,0,STATE_OFF   ,"Run Selector" },
	{ PT_BUTTON ,   5, 255, 155,  25,0,STATE_OFF   ,"Test..." },
	{ PT_LINE   ,   5, 290, 320,   0,0,STATE_OFF   ,"line" },
	{ PT_STEXT  ,   5, 300, 132,  25,0,STATE_LEFT  ,"< Calibration Points >" },
	{ PT_RADIO  ,  37, 325,  68,  25,3,STATE_ON    ,"2 points" },
	{ PT_RADIO  ,  37, 350,  68,  25,3,STATE_OFF   ,"3 points" },
	{ PT_RADIO  ,  37, 375,  68,  25,3,STATE_OFF   ,"4 points" },
	{ PT_RADIO  ,  37, 400,  68,  25,3,STATE_OFF   ,"5 points" },
	{ PT_RADIO  ,  37, 425,  68,  25,3,STATE_OFF   ,"9 points" },
	{ PT_STEXT  , 147, 300, 144,  25,0,STATE_LEFT  ,"< Calibration Time Out >" },
	{ PT_RADIO  , 191, 325,  56,  25,4,STATE_ON    ,"10 sec" },
	{ PT_RADIO  , 191, 350,  56,  25,4,STATE_OFF   ,"20 sec" },
	{ PT_RADIO  , 191, 375,  56,  25,4,STATE_OFF   ,"60 sec" },
	{ PT_BUTTON ,   5, 455, 320,  25,0,STATE_OFF   ,"Calibration#1..." },
};
uControlTable ctltbvga[] =
{
	{ PT_BUTTON , 526,   5,  64,  25,0,STATE_OFF   ,"RELEASE_VERSION },
	{ PT_STEXT  ,   5,  25, 102,  25,0,STATE_LEFT  ,"< Sampling Rate >" },
	{ PT_RADIO  ,  25,  50,  62,  25,1,STATE_OFF   ,"30 p/s" },
	{ PT_RADIO  ,  25,  75,  62,  25,1,STATE_OFF   ,"50 p/s" },
	{ PT_RADIO  ,  25, 100,  62,  25,1,STATE_OFF   ,"80 p/s" },
	{ PT_RADIO  ,  25, 125,  62,  25,1,STATE_OFF   ,"100 p/s" },
	{ PT_RADIO  ,  25, 150,  62,  25,1,STATE_OFF   ,"130 p/s" },
	{ PT_RADIO  ,  25, 175,  62,  25,1,STATE_ON    ,"150 p/s" },
	{ PT_RADIO  ,  25, 200,  62,  25,1,STATE_OFF   ,"Point mode" },
	{ PT_STEXT  , 117,  25, 126,  25,0,STATE_LEFT  ,"      < Sound >      " },
	{ PT_CKBOX  , 116,  50, 126,  25,0,STATE_ON    ,"Touch Down Beep on" },
	{ PT_CKBOX  , 116,  75, 126,  25,0,STATE_ON    ,"Touch Up Beep on" },
	{ PT_BUTTON ,   5, 225, 140,  25,0,STATE_OFF   ,"Apply" },
	{ PT_BUTTON , 155, 225, 120,  25,0,STATE_OFF   ,"Run Selector" },
	{ PT_BUTTON ,   5, 255, 140,  25,0,STATE_OFF   ,"Test..." },
	{ PT_STEXT  , 300,  25, 132,  25,0,STATE_LEFT  ,"< Calibration Points >" },
	{ PT_RADIO  , 332,  50,  68,  25,3,STATE_ON    ,"2 points" },
	{ PT_RADIO  , 332,  75,  68,  25,3,STATE_OFF   ,"3 points" },
	{ PT_RADIO  , 332, 100,  68,  25,3,STATE_OFF   ,"4 points" },
	{ PT_RADIO  , 332, 125,  68,  25,3,STATE_OFF   ,"5 points" },
	{ PT_RADIO  , 332, 150,  68,  25,3,STATE_OFF   ,"9 points" },
	{ PT_STEXT  , 442,  25, 144,  25,0,STATE_LEFT  ,"< Calibration Time Out >" },
	{ PT_RADIO  , 486,  50,  56,  25,4,STATE_ON    ,"10 sec" },
	{ PT_RADIO  , 486,  75,  56,  25,4,STATE_OFF   ,"20 sec" },
	{ PT_RADIO  , 486, 100,  56,  25,4,STATE_OFF   ,"60 sec" },
	{ PT_BUTTON , 300, 225, 298,  25,0,STATE_OFF   ,"Calibration#1..." },
};
uControlTable ctltbdual[] =
{
	{ PT_BUTTON , 526,   5,  64,  23,0,STATE_OFF ,RELEASE_VERSION },
	{ PT_STEXT  ,   5,  23, 102,  23,0,STATE_LEFT,"< Sampling Rate >" },
	{ PT_RADIO  ,  25,  46,  62,  23,1,STATE_OFF ,"30 p/s" },
	{ PT_RADIO  ,  25,  69,  62,  23,1,STATE_OFF ,"50 p/s" },
	{ PT_RADIO  ,  25,  92,  62,  23,1,STATE_OFF ,"80 p/s" },
	{ PT_RADIO  ,  25, 115,  62,  23,1,STATE_OFF ,"100 p/s" },
	{ PT_RADIO  ,  25, 138,  62,  23,1,STATE_OFF ,"130 p/s" },
	{ PT_RADIO  ,  25, 161,  62,  23,1,STATE_ON  ,"150 p/s" },
	{ PT_RADIO  ,  25, 184,  62,  23,1,STATE_OFF ,"Point mode" },
	{ PT_STEXT  , 117,  23, 126,  23,0,STATE_LEFT,"      < Sound >      " },
	{ PT_CKBOX  , 116,  46, 126,  23,0,STATE_ON  ,"Touch Down Beep on" },
	{ PT_CKBOX  , 116,  69, 126,  23,0,STATE_ON  ,"Touch Up Beep on" },
	{ PT_BUTTON ,   5, 207, 140,  23,0,STATE_OFF ,"Apply" },
	{ PT_BUTTON , 155, 207, 120,  23,0,STATE_OFF ,"Run Selector" },
	{ PT_STEXT  ,   5, 235, 114,  18,0,STATE_LEFT,"< Desktops Layout >" },
	{ PT_RADIO  ,  30, 258, 224,  18,2,STATE_OFF ,"individual desktops" },
	{ PT_RADIO  ,  30, 276, 224,  18,2,STATE_ON  ,"spanning desktops(left of Screen1)" },
	{ PT_RADIO  ,  30, 294, 224,  18,2,STATE_OFF ,"spanning desktops(right of Screen1)" },
	{ PT_RADIO  ,  30, 312, 224,  18,2,STATE_OFF ,"spanning desktops(above Screen1)" },
	{ PT_RADIO  ,  30, 330, 224,  18,2,STATE_OFF ,"spanning desktops(below Screen1)" },
	{ PT_BUTTON ,   5, 353,  64,  23,0,STATE_OFF ,"Test#1..." },
	{ PT_BUTTON ,  79, 353,  64,  23,0,STATE_OFF ,"Test#2..." },
	{ PT_STEXT  , 300,  23, 132,  23,0,STATE_LEFT,"< Calibration Points >" },
	{ PT_RADIO  , 332,  46,  68,  23,3,STATE_ON  ,"2 points" },
	{ PT_RADIO  , 332,  69,  68,  23,3,STATE_OFF ,"3 points" },
	{ PT_RADIO  , 332,  92,  68,  23,3,STATE_OFF ,"4 points" },
	{ PT_RADIO  , 332, 115,  68,  23,3,STATE_OFF ,"5 points" },
	{ PT_RADIO  , 332, 138,  68,  23,3,STATE_OFF ,"9 points" },
	{ PT_STEXT  , 442,  23, 144,  23,0,STATE_LEFT,"< Calibration Time Out >" },
	{ PT_RADIO  , 486,  46,  56,  23,4,STATE_ON  ,"10 sec" },
	{ PT_RADIO  , 486,  69,  56,  23,4,STATE_OFF ,"20 sec" },
	{ PT_RADIO  , 486,  92,  56,  23,4,STATE_OFF ,"60 sec" },
	{ PT_BUTTON , 300, 207, 145,  23,0,STATE_OFF ,"Calibration#1..." },
	{ PT_BUTTON , 453, 207, 145,  23,0,STATE_OFF ,"Calibration#2..." },
};

/*
*/
#define	S_RATE_GROUP		1
int srate = 5;	/* 5=150p/s */
char *sratetb[] =
	{ "30 p/s","50 p/s","80 p/s","100 p/s","130 p/s","150 p/s","Point mode",NULL };
#define	B_DOWN_BELL		(1<<B_BEEP_UP_ON)
#define	B_UP_BELL		(1<<B_BEEP_DOWN_ON)
int touchbell = B_DOWN_BELL|B_UP_BELL;
/*
*/
int bellcount = 2;
char *belltb[] = { "Touch Down Beep on","Touch Up Beep on",NULL };
/*
*/
#define	DESKTOPS_GROUP		2
extern int dtop_num;
char *dtoptb[] = 
{
	"individual desktops",
	"spanning desktops(left of Screen1)",
	"spanning desktops(right of Screen1)",
	"spanning desktops(above Screen1)",
	"spanning desktops(below Screen1)",
	NULL 
};
/*
*/
#define	CALIB_POINT_GROUP	3
int calib_point_num = 2;
char *calibtb[] =
	{ "2 points","3 points","4 points","5 points","6 points","9 points",NULL };
/*
*/
#define	CALIB_TIMOUT_GROUP	4
int calib_timeout = 10;
char *totb[] = { "10 sec","20 sec","60 sec",NULL };

int main(int argc,char *argv[])
{
int i,k;
	setbuf(stdin,0);
	setbuf(stdout,0);
	snum = 0;
	scr_vga = false;
	scr_dual = false;
	for( k=0,i=1 ; i < argc ; i++ )
	{
		if( argv[i][0] == '-' )
		{
			switch( argv[i][1] )
			{
			case	0:		k++;					break;
			case	'c': 	fork_cur_dir = true;	break;
			case	'd':	scr_dual = true;		break;
			case	'v': 	scr_vga = true;			break;
			default:		prhelp();				break;
			}
		}
		else
		{
			switch( k )
			{
			case	0:	snum = atoi(argv[i]);	break;
			}
			k++;
		}
	}
	domain();
	return(0);
}
void prhelp()
{
	fprintf(stderr,"Syntax:tbctl {<Option>} \n");
	fprintf(stderr,"Function: %s DMC touch-panel Control Main on X-Window\n",ProductName);
	fprintf(stderr,"Option:\n");
	fprintf(stderr,"    -?     help\n");
	exit(0);
}

void domain()
{
uWindowPtr win;
uColor fgcolor,bgcolor;
int btnum[20];
#define	BTNUM_VER		0
#define	BTNUM_APPLY		1
#define	BTNUM_SELECTOR	2
#define	BTNUM_TEST		3
#define	BTNUM_CALIB		7
uControlPtr ctl[50];
int ctlnum;
int srate_base,bell_base;
int dtop_base;
XEvent ev;
Cursor cs;
uRect r;
int end,i,x,y,w,h,ww,x1,y1,y2,base;
KeySym key;
char s[100];
int scr_640,bx1,by1;
int sn;
int chg;
int lineh;
	init_ulib();
	sDisp = set_port(snum);
	if( (i=open_xinput_driver("DMC")) < 0 )
		return;
	if( gScreenCount >= 2 )
		scr_dual = true;
	memset(btnum,-1,sizeof(btnum));
	touchbell = get_beep();
	srate = get_samp_rate();
	calib_point_num = get_calib_point_num();
	get_display_rect(&r);
	printf("dispay (%d,%d)-(%d,%d)\n",r.x,r.y,r.width,r.height);
	if( scr_dual )
	{
		x1 = y1 = 0;
		for( i=0 ; i < MAX_SCREEN ; i++ )
		{
			if( get_scr_max(i,&x,&y) == 0)
			{
				max_dat[i].x = 0;	//x1;
				max_dat[i].y = 0;	//y1;
				max_dat[i].width = x;
				max_dat[i].height = y;
				printf("(%d)MAX = (%d,%d)-(%d,%d)\n",i,x1,y1,x,y);
				r.width -= x;
				r.height -= y;
				if( r.width > 0 )
					x1 += x;
				if( r.height > 0 )
					y1 += y;
			}
		}
		get_display_rect(&r);
		if( r.width != max_dat[0].width )
		{
			r.width = max_dat[0].width;
			r.height = max_dat[0].height;
		}
	}
	if( scr_vga || scr_dual )
		scr_640 = 1;
	else
		scr_640 = r.width < 800 ? 1 : 0;
	if( scr_640 )
	{
		w = 600;
		h = 270;
	}
	else
	{
		w = 330;
	#ifdef _3MEX2
		h = 370;
	#else
	#if	CALIB_SET_234569
		h = 490;
	#else
		h = 465;
	#endif
	#endif
	}
#if ENABLE_POINT_MODE
	h += 25;
#endif
	if( scr_dual )
		h += 120;
	x = (r.width/2) - (w/2);
	y = (r.height/4) - (h/2);
	if( r.height <= 480 )
	{
		y = 0;
		lineh = 18;
	}
	else
	{
		if( y <= 10 )
			y = 50;
		lineh = 20;
	}
	set_rect(&r,x,y,w,h);
	//fgcolor = BlackPixel(sDisp,snum);
	fgcolor = get_color(0,0,0);
	bgcolor = get_color(0xe000,0xe000,0xe000);
	sprintf(s,"%s Control Main",ProductName);
	win = new_window(&r,s,fgcolor,bgcolor,false);
	// +----------------------------------------------------+
	// |                                          Ver.1.0.1 |
	// | < Sampling Rate >      < Sound >                   | <-- y1
	// |      30 p/s         Touch Down Beep on             |
	// |      50 p/s         Touch Up Beep on               |
	// |      80 p/s                                        |
	// |     100 p/s                                        |
	// |     130 p/s                                        |
	// |     150 p/s                                        |
	// |     Point mode                                     |
	// | +---------------------+ +------------------------+ |
	// | |       Apply         | |      Run Selector      | |
	// | +---------------------+ +------------------------+ |
	// | < Desktop Layout >                                 |
	// |     individual desktops                            |
	// |     spanning desktops (left of Screen1)            |
	// |     spanning desktops (right of Screen1)           |
	// |     spanning desktops (above Screen1)              |
	// |     spanning desktops (below Screen1)              |
	// | +---------------------+                            |
	// | |      Test...        |                            |
	// | +---------------------+                            |
	// | < Calibration Points > < Calibration Time Out >    | <-- y1
	// |     2 points              10 sec                   |
	// |                           20 sec                   |
	// |                           60 sec                   |
	// | +------------------------------------------------+ |
	// | |               Calibration...                   | |
	// | +------------------------------------------------+ |
	// +----------------------------------------------------+
	//   |
	//   x1
	XMoveWindow(sDisp,win->win,x,y);
	x1 = x = (w/2) - ((w-10)/2);
	y = 5;
	w -= 10;
	h = lineh+5;
	ctlnum = 0;
	strcpy(s,RELEASE_VERSION);
	w = get_text_width(win,s);
	set_rect(&r,r.width-w-20,y,w+10,h);
	btnum[BTNUM_VER] = ctlnum;
	ctl[ctlnum++] = new_control(win,PT_BUTTON,s,&r,STATE_OFF,0);
	y += lineh;
	y1 = y;
#ifdef _3MEX2
	y2 = 0;
#else
	strcpy(s,"< Sampling Rate >");
	w = get_text_width(win,s);
	set_rect(&r,x,y,w,h);
	ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
	ww = get_text_width(win,sratetb[5]) + 20;
	x = x + (w/2) - (ww/2);
	for( i=0,srate_base=base=ctlnum ; sratetb[i] ; i++ )
	{
		y += (lineh + 5);
		set_rect(&r,x,y,ww,h);
		ctl[ctlnum++] = new_control(win,PT_RADIO,sratetb[i],&r,STATE_OFF,S_RATE_GROUP);
		if( srate == i )
			ctl[base+i]->state = STATE_ON;
	}
	y += (lineh + 5);
	y2 = y;
	x = x1 + w + 10;
	y = y1;
#endif
	strcpy(s,"      < Sound >      ");
	w = get_text_width(win,s);
	set_rect(&r,x,y,w,h);
	ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
	ww = get_text_width(win,belltb[0]) + 20;
	x = x + (w/2) - (ww/2);
	for( i=0,bell_base=base=ctlnum ; belltb[i] ; i++ )
	{
		y += (lineh + 5);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_CKBOX,belltb[i],&r,STATE_OFF,0);
		if( touchbell & (1<<(bellcount-i-1)) )
			ctl[base+i]->state = STATE_ON;
	}
	y += (lineh + 5);
	if( y2 < y )
		y2 = y;
	get_win_rect(&r,win);
	x = x1;
	y = y2;
	if( scr_640 )
		w = (r.width/4) - 10;
	else
		w = (r.width/2) - 10;
	by1 = y;
	h = lineh + 5;
	set_rect(&r,x,y,w,h);
	btnum[BTNUM_APPLY] = ctlnum;
	ctl[ctlnum++] = new_control(win,PT_BUTTON,"Apply",&r,STATE_OFF,0);
	x += w + 10;
	if( scr_640 )
		set_rect(&r,x,y,w-20,h);
	else
		set_rect(&r,x,y,w,h);
	btnum[BTNUM_SELECTOR] = ctlnum;
	ctl[ctlnum++] = new_control(win,PT_BUTTON,"Run Selector",&r,STATE_OFF,0);
	bx1 = x + w + 5;
	x = x1;
	y += lineh + 5;
	y += 5;
	/**/
	if( scr_dual )
	{
		h = lineh;
		strcpy(s,"< Desktops Layout >");
		w = get_text_width(win,s);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
		x = 30;
		ww = get_text_width(win,dtoptb[1]) + 20;
		x = x;	/*  + (w/2) - (ww/2); */
		y += 5;
		for( i=0,dtop_base=base=ctlnum ; dtoptb[i] ; i++ )
		{
			y += (lineh);	/*  + 5); */
			set_rect(&r,x,y,ww,h);
			ctl[ctlnum++] = new_control(win,PT_RADIO,dtoptb[i],&r,STATE_OFF,DESKTOPS_GROUP);
			if( dtop_num == i )
				ctl[base+i]->state = STATE_ON;
		}
		y += (lineh + 5);
		y2 = y;
		x = x1;
		h = lineh + 5;
		w = get_text_width(win,"Test#x...") + 10;
		for( i=0 ; i < MAX_SCREEN ; i++ )
		{
			set_rect(&r,x,y,w,h);
			btnum[BTNUM_TEST+i] = ctlnum;
			sprintf(s,"Test#%d...",i+1);
			ctl[ctlnum++] = new_control(win,PT_BUTTON,s,&r,STATE_OFF,0);
			x += (w+10);
		}
	}
	else
	{
		h = lineh + 5;
		//w = get_text_width(win,"Test...") + 10;
		set_rect(&r,x,y,w,h);
		btnum[BTNUM_TEST] = ctlnum;
		sprintf(s,"Test...");
		ctl[ctlnum++] = new_control(win,PT_BUTTON,s,&r,STATE_OFF,0);
		x += (w+10);
	}
	x = x1;
	y += (lineh+5);
	y += 10;
	get_win_rect(&r,win);
	w = r.width - 10;
	set_rect(&r,x,y,w,0);
	if( scr_640 )
	{
		x1 = x = bx1;
		y = y1;
		strcpy(s,"< Calibration Points >");
		w = get_text_width(win,s);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
		ww = get_text_width(win,calibtb[0]) + 20;
		x = x + (w/2) - (ww/2);
		for( i=0,base=ctlnum ; calibtb[i] ; i++ )
		{
			y += (lineh + 5);
			set_rect(&r,x,y,ww,h);
			ctl[ctlnum++] = new_control(win,PT_RADIO,calibtb[i],&r,STATE_OFF,CALIB_POINT_GROUP);
			if( calib_point_num == atoi(calibtb[i]) )
				ctl[base+i]->state = STATE_ON;
		}
		y2 = y;
		x = x1 + w + 10;
		y = y1;
		strcpy(s,"< Calibration Time Out >");
		w = get_text_width(win,s);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
		ww = get_text_width(win,totb[0]) + 20;
		x = x + (w/2) - (ww/2);
		for( i=0,base=ctlnum ; totb[i] ; i++ )
		{
			y += (lineh + 5);
			set_rect(&r,x,y,ww,h);
			ctl[ctlnum++] = new_control(win,PT_RADIO,totb[i],&r,STATE_OFF,CALIB_TIMOUT_GROUP);
			if( calib_timeout == atoi(totb[i]) )
				ctl[base+i]->state = STATE_ON;
		}
		y = y2 >= y ? y2 : y;
		x = x1;
		y = by1;
		get_win_rect(&r,win);
		w = (r.width - bx1) - (2 * gScreenCount);
		w = (w / gScreenCount);
		for( i=0 ; i < gScreenCount ; i++ )
		{
			if( gScreenCount >= 3 )
				sprintf(s,"Calib#%d...",i+1);
			else
				sprintf(s,"Calibration#%d...",i+1);
			set_rect(&r,x,y,w,h);
			btnum[BTNUM_CALIB+i] = ctlnum;
			ctl[ctlnum++] = new_control(win,PT_BUTTON,s,&r,STATE_OFF,0);
			x += (w+2);
		}
	}
	else
	{
		ctl[ctlnum++] = new_control(win,PT_LINE,"line",&r,STATE_OFF,0);
		y += 10;
		y1 = y;
		strcpy(s,"< Calibration Points >");
		w = get_text_width(win,s);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
		ww = get_text_width(win,calibtb[0]) + 20;
		x = x + (w/2) - (ww/2);
		for( i=0,base=ctlnum ; calibtb[i] ; i++ )
		{
			y += (lineh + 5);
			set_rect(&r,x,y,ww,h);
			ctl[ctlnum++] = new_control(win,PT_RADIO,calibtb[i],&r,STATE_OFF,CALIB_POINT_GROUP);
			if( calib_point_num == atoi(calibtb[i]) )
				ctl[base+i]->state = STATE_ON;
		}
		y2 = y;
		x = x1 + w + 10;
		y = y1;
		strcpy(s,"< Calibration Time Out >");
		w = get_text_width(win,s);
		set_rect(&r,x,y,w,h);
		ctl[ctlnum++] = new_control(win,PT_STEXT,s,&r,STATE_LEFT,0);
		ww = get_text_width(win,totb[0]) + 20;
		x = x + (w/2) - (ww/2);
		for( i=0,base=ctlnum ; totb[i] ; i++ )
		{
			y += (lineh + 5);
			set_rect(&r,x,y,ww,h);
			ctl[ctlnum++] = new_control(win,PT_RADIO,totb[i],&r,STATE_OFF,CALIB_TIMOUT_GROUP);
			if( calib_timeout == atoi(totb[i]) )
				ctl[base+i]->state = STATE_ON;
		}
		y = y2 >= y ? y2 : y;
		x = x1;
		y += (lineh + 5 + 5);
		get_win_rect(&r,win);
		w = r.width - (x1*2);
		w = (w / gScreenCount);
		for( i=0 ; i < gScreenCount ; i++ )
		{
			if( gScreenCount >= 3 )
				sprintf(s,"Calib#%d...",i+1);
			else
				sprintf(s,"Calibration#%d...",i+1);
			set_rect(&r,x,y,w,h);
			btnum[BTNUM_CALIB+i] = ctlnum;
			ctl[ctlnum++] = new_control(win,PT_BUTTON,s,&r,STATE_OFF,0);
			x += (w+1);
		}
	}
	ctl[ctlnum] = NULL;
	if( ctlnum >= (sizeof(ctl)/sizeof(uControlPtr)) )
	{
		printf("BUFFER ERROR\n");
		exit(0);
	}
	XSelectInput(sDisp,win->win,NormalMask);
	draw_control(ctl,ctlnum);
#if 1
	dinfo_control(ctl,ctlnum);
#endif
	pid = -1;
	for( end=false ; !end ; )
	{
		if( pid != -1 )
		{
			if( waitpid(pid,NULL,WNOHANG) == pid )
				pid = -1;;
		}
		XNextEvent(sDisp,&ev);
		switch( ev.type )
		{
		case	KeyPress:
			if( XLookupString(&ev.xkey,s,10,&key,NULL) >= 1 )
			{
				switch( s[0] )
				{
					case 'e': end = true;		break;
				}
			}
			break;
		case	ButtonPress:
			ctl_mouse_on(ctl,ctlnum,&ev);
			break;
		case	ButtonRelease:
			if( (i = ctl_mouse_off(ctl,ctlnum,&ev)) == -1 )
				break;
			if( i == btnum[BTNUM_VER] )		// ver button
			{
				wVer(win);
				draw_control(ctl,ctlnum);
			}
			else if( i == btnum[BTNUM_APPLY] )		// apply button
			{
				cs = XCreateFontCursor(sDisp,XC_clock);
				XDefineCursor(sDisp,win->win,cs);
				XFlush(sDisp);
			#ifdef _3MEX2
				y2 = 0;
			#else
				i = find_radio_group_on(ctl,ctlnum,S_RATE_GROUP);
				// ++++++++++++ set sample rate ++++++++++++++++
				y2 = i - srate_base;
				if( set_samp_rate(y2) == -1 )
				{
					XUndefineCursor(sDisp,win->win);
					msgbox("Error","set samp rate error",MB_OK,0);
					break;
				}
				srate = y2;
			#endif
				// ++++++++++++ set beep ++++++++++++++++
				if( ctl[bell_base+0]->state == STATE_ON )
					y2 |= B_DOWN_BELL;
				else
					y2 &= (~B_DOWN_BELL);
				if( ctl[bell_base+1]->state == STATE_ON )
					y2 |= B_UP_BELL;
				else
					y2 &= (~B_UP_BELL);
				set_beep(1,(y2&B_DOWN_BELL?1:0));
				set_beep(0,(y2&B_UP_BELL?1:0));
				save_exec();
				touchbell = y2;
			#ifndef _3MEX2
				// ++++++++++++ do reset ++++++++++++++++
				sleep(2);
				reset_tb();
			#endif
				XUndefineCursor(sDisp,win->win);
			}
			else if( (btnum[BTNUM_TEST] <= i) && (i < (btnum[BTNUM_TEST]+MAX_SCREEN)) )
			{
			    sn = i - btnum[BTNUM_TEST];
				if( scr_dual )
				{
					chg = false;
					i = find_radio_group_on(ctl,ctlnum,DESKTOPS_GROUP);
					y2 = i - dtop_base;
					if( dtop_num != y2 )
						chg = true;
					dtop_num = y2;
					if( chg )
						write_dmc_util();
				}
				pid = run_exec(sn,CMD_TBTEST);
			}
			else if( i == btnum[BTNUM_SELECTOR] )	// selector button
			{
				pid = run_exec(-1,CMD_SELECTOR);
			}
			else if( (btnum[BTNUM_CALIB] <= i) && (i < (btnum[BTNUM_CALIB]+MAX_SCREEN)) )
			{
				sn = i - btnum[BTNUM_CALIB];
				if( scr_dual )
				{
					chg = false;
					i = find_radio_group_on(ctl,ctlnum,DESKTOPS_GROUP);
					y2 = i - dtop_base;
					if( dtop_num != y2 )
						chg = true;
					dtop_num = y2;
					if( chg )
						write_dmc_util();
			    }
				i = find_radio_group_on(ctl,ctlnum,CALIB_POINT_GROUP);
				calib_point_num = atoi(ctl[i]->s);
				i = find_radio_group_on(ctl,ctlnum,CALIB_TIMOUT_GROUP);
				calib_timeout = atoi(ctl[i]->s);
				pid = run_exec(sn,CMD_TBCALIB);
			}
			break;
		case	MotionNotify:
		case	LeaveNotify:
			break;
		case	Expose:	/* = window draw */
			draw_control(ctl,ctlnum);
			break;
		case	ClientMessage:
			if( ev.xclient.message_type == win->a1 && ev.xclient.data.l[0] == win->a2 )
				end = true;
			break;
		case	DestroyNotify:
			end = true;
			break;
		}
	}
	destroy_window(win);
	term_ulib();
}
int run_exec(int snum,int cmd)
{
char s[100],path[100];
int x,y,wx,wy;
	path[0] = 0;
	if( fork_cur_dir )
		strcpy(path,"./");
	switch( cmd )
	{
	case	CMD_TBCALIB:
		if( find_ps("tbcalib") )
			return(-1);
		get_xy_at_dual(snum,&x,&y,&wx,&wy);
		sprintf(s,"%stbcalib %d %d %d %d %d %d %d&",path,calib_point_num,calib_timeout,snum,x,y,wx,wy);
		break;
	case	CMD_TBTEST:
		if( find_ps("tbtest") )
			return(-1);
		get_xy_at_dual(snum,&x,&y,&wx,&wy);
		sprintf(s,"%stbtest 1 %d %d %d %d %d&",path,snum,x,y,wx,wy);
		break;
	case	CMD_SELECTOR:
		if( find_ps("tbselector") )
		{
			msgbox("Warning!!","Don't run at same time",MB_OK,0);
			return(-1);
		}
		sprintf(s,"%stbselector &",path);
		break;
	default:
		return(-1);
	}
	printf("CMD [%s]\n",s);
	system(s);
	return(-1);
}
int get_xy_at_dual(int snum,int *x,int *y,int *wx,int *wy)
{
uRect r;
int a;
	get_display_rect(&r);
	*x = 0;
	*y = 0;
	*wx = r.width;
	*wy = r.height;
	if( !scr_dual )
		return(-1);
	*wx = max_dat[snum].width;
	*wy = max_dat[snum].height;
	switch( dtop_num )
	{
	case	0:	/* individual desktops */
		break;
	case	1:	/* spanning desktops(left of scr1) */
		*x = snum == 0 ? 0 : max_dat[0].width;
		*y = 0;
		break;
	case	2:	/* spanning desktops(right of scr1) */
		*x = snum == 0 ? max_dat[1].width : 0;
		*y = 0;
		break;
	case	3:	/* spanning desktops(above scr1) */
		*x = 0;
		*y = snum == 0 ? 0 : max_dat[0].height;
		break;
	case	4:	/* spanning desktops(below scr1) */
		*x = 0;
		*y = snum == 0 ? max_dat[1].height : 0;
		break;
	default:
		return(-1);
	}
	return(0);
}

/***************************************************************************
 *
 */
int wVer(uWindowPtr par_w)
{
uWindowPtr win;
uControlPtr ctl[3];
XEvent ev;
uRect r;
uColor fgcolor,bgcolor;
int x,y,w,h,msg_y;
int end,i,res;
Cursor cs;
char title[100];
	get_display_rect(&r);
	if( scr_dual && r.width != max_dat[0].width )
	{
		r.width = max_dat[0].width;
		r.height = max_dat[0].height;
	}
	fgcolor = BlackPixel(sDisp,snum);
	//bgcolor = WhitePixel(sDisp,snum);
	bgcolor = get_color(0xe000,0xe000,0xe000);
	w = r.width;
	h = r.height;
	x = r.x + (w / 2) - 150;
	w = 300;
	y = r.y + (h / 5);
	h = 110;
	msg_y = 20;
	set_rect(&r,x,y,w,h);
	sprintf(title,"%s Version Information",ProductName);
	win = new_window(&r,title,fgcolor,bgcolor,false);
	XFlush(sDisp);
	XMoveWindow(sDisp,win->win,x,y);
	XSelectInput(sDisp,win->win,NormalMask);
	wVer_draw_win(win,msg_y);
	XFlush(sDisp);
	for( res=0,end=false ; !end ; )
	{
		XNextEvent(sDisp,&ev);
		switch( ev.type )
		{
		case	ButtonPress:
			break;
		case	ButtonRelease:
			end = true;
			break;
		case	Expose:	/* = window draw */
			wVer_draw_win(win,msg_y);
			break;
		case	ClientMessage:
			if( ev.xclient.message_type == win->a1 && ev.xclient.data.l[0] == win->a2 )
				end = true;
			break;
		case	DestroyNotify:
			end = true;
			break;
		}
	}
	destroy_window(win);
	XFlush(sDisp);
	return(res);
}
void wVer_draw_win(uWindowPtr win,int y)
{
uRect r;
int i,x,w;
char s[100];
	get_win_rect(&r,win);
	sprintf(s,"relase       :      %s",RELEASE_VERSION);
	w = get_text_width(win,s);
	x = r.x + (r.width/2) - (w/2);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
	y += 20;
	sprintf(s,"tbctl        :      %s",TBCTL_VERSION);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
	y += 20;
	sprintf(s,"dmc_drv      :      %s",TBDRV_VERSION);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
#ifndef _3MEX2
	y += 20;
	sprintf(s,"usbdmc       :      %s",TBUSB_VERSION);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
	y += 20;
	sprintf(s,"tpdmc        :      %s",FILTERUSB_VERSION);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
#endif
}

