/*
 *
 * Copyright (c) 2004  DMC Co., Ltd.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
 * OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 * Except as contained in this notice, the name of the DMC Co., Ltd shall not 
 * be used in advertising or otherwise to promote the sale, use or other dealings
 * in this Software without prior written authorization from DMC Co., Ltd.
 */
/*
 * EUC
 * tab=4
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
//#include <curses.h>
#include "tb.h"

#define	C_ESC	0x1b

int main(int argc,char *argv[]);
void prhelp();
void local_check(BOOL no_wm);
void draw_disp(uWindowPtr win,uRect *r,BOOL no_wm);
void draw_xy(uWindowPtr win,int nx,int ny);
void draw_line(uWindowPtr win,int nx,int nt,int init);

unsigned long fgcolor,bgcolor;

int snum = 0;
static Display *sDisp;
int stx = 0;
int sty = 0;
int wx;
int wy;

int main(int argc,char *argv[])
{
BOOL no_wm,i,k;
uRect r;
	setbuf(stdin,0);
	setbuf(stdout,0);
	no_wm = false;
	snum = 0;
	stx = sty = 0;
	init_ulib();
	set_port(snum);
	get_display_rect(&r);
	wx = r.width;
	wy = r.height;
	for( k=0,i=1 ; i < argc ; i++ )
	{
		if( argv[i][0] == '-' )
		{
			switch( argv[i][1] )
			{
			case	0:	k++;		break;
			default:	prhelp();	break;
			}
		}
		else
		{
			switch( k )
			{
			case	0:	no_wm = atoi(argv[i]);	break;
			case	1:	snum = atoi(argv[i]);	break;
			case	2:	stx = atoi(argv[i]);	break;
			case	3:	sty = atoi(argv[i]);	break;
			case	4:	wx = atoi(argv[i]);		break;
			case	5:	wy = atoi(argv[i]);		break;
			}
			k++;
		}
	}
	local_check(no_wm);
	return(0);
}
void prhelp()
{
	fprintf(stderr,"Syntax:tbtest {<Option>} \n");
	fprintf(stderr,"Function: %s DMC touch-panel check on X-Window\n",ProductName);
	fprintf(stderr,"Option:\n");
	fprintf(stderr,"    -?     help\n");
	exit(0);
}

#define	TOP_X	0
#define	TOP_Y	110

void local_check(BOOL no_wm)
{
uWindowPtr win;
XEvent ev;
uRect r;
int doing;
int end,i;
KeySym key;
uColor c1,c2,c3,c;
char s[100];
uControlPtr ctl;
	sDisp = set_port(snum);
	set_rect(&r,stx,sty,wx,wy);
	fgcolor = get_color(0,0,0);
	bgcolor = get_color(0xe800,0xe800,0xe800);
	sprintf(s,"%s Panel Test",ProductName);
	win = new_window(&r,s,fgcolor,bgcolor,no_wm);
	set_rect(&r,0,0,wx,wy);
	XSelectInput(sDisp,win->win,NormalMask);
	XSetInputFocus(sDisp,win->win,RevertToParent,CurrentTime);
	set_rect(&r,TOP_X+10,TOP_Y+5,80,20);
	ctl = new_control(win,PT_BUTTON,"close",&r,STATE_OFF,0);
	set_rect(&r,0,0,wx,wy);
	draw_disp(win,&r,no_wm);
	draw_control(&ctl,1);
	c1 = get_color(0,0,0);
	c2 = get_color(0xffff,0,0);
	c3 = get_color(0,0xffff,0);
	//printf("COLOR %08x %08x %08x %08x %08x\n",c1,c2,c3,fgcolor,bgcolor);
	doing = 0;
	for( end=0 ; !end ; )
	{
		XNextEvent(sDisp,&ev);
		switch( ev.type )
		{
		case	KeyPress:
			if( XLookupString(&ev.xkey,s,10,&key,NULL) >= 1 && s[0] == C_ESC )
				end = true;
			//printf("in %x\n",s[0]);
			break;
		case	ButtonPress:
			XSetInputFocus(sDisp,win->win,RevertToParent,CurrentTime);
			if( ctl_mouse_on(&ctl,1,&ev) == -1 )
			{
				doing = true;
				//printf("state = $%x\n",ev.xbutton.button);
				switch( ev.xbutton.button )
				{
				case	2:	c = c2;	break;
				case	3:	c = c3;	break;
				default:	c = c1;	break;
				}
				XSetForeground(sDisp,win->gc,c);
				draw_line(win,ev.xbutton.x,ev.xbutton.y,false);
				draw_xy(win,ev.xbutton.x,ev.xbutton.y);
				//printf("ON  = %d,%d\n",ev.xbutton.x,ev.xbutton.y);
				XSetForeground(sDisp,win->gc,fgcolor);
			}
			break;
		case	MotionNotify:
			if( doing )
			{
				XSetForeground(sDisp,win->gc,c);
				draw_line(win,ev.xmotion.x,ev.xmotion.y,false);
				draw_xy(win,ev.xmotion.x,ev.xmotion.y);
				XSetForeground(sDisp,win->gc,fgcolor);
			}
			//printf("mov = %d,%d\n",ev.xbutton.x,ev.xbutton.y);
			break;
		case	ButtonRelease:
			if( ctl_mouse_off(&ctl,1,&ev) != -1 )
			{
				end = 1;
				break;
			}
		case	LeaveNotify:
			doing = false;
			XSetForeground(sDisp,win->gc,c);
			draw_line(win,0,0,true);
			draw_xy(win,ev.xbutton.x,ev.xbutton.y);
			XSetForeground(sDisp,win->gc,fgcolor);
			//printf("off = %d,%d\n",ev.xbutton.x,ev.xbutton.y);
			break;
		case	Expose:	/* = window draw */
			draw_disp(win,&r,no_wm);
			draw_control(&ctl,1);
			break;
		case	ClientMessage:
			if( ev.xclient.message_type == win->a1 && ev.xclient.data.l[0] == win->a2 )
				end = 1;
			break;
		case	DestroyNotify:
			end = 1;
			break;
		}
	}
	destroy_window(win);
	term_ulib();
}
void draw_disp(uWindowPtr win,uRect *r,BOOL no_wm)
{
char s[100];
int x,y,w;
	if( no_wm )
		sprintf(s,"Exit when input ESC key OR click close button.");
	else
		sprintf(s,"Exit when input ESC key OR click window-close button.");
	w = get_text_width(win,s);
	x = r->x + (r->width / 2) - (w /2);
	y = r->y + (r->height / 3);
	XDrawString(sDisp,win->win,win->gc,x,y,s,strlen(s));
	for( x=100 ; x < r->width ; x+=100 )
		XDrawLine(sDisp,win->win,win->gc,x,0,x,r->height);
	for( y=100 ; y < r->height ; y+=100 )
		XDrawLine(sDisp,win->win,win->gc,0,y,r->width,y);
}
void draw_xy(uWindowPtr win,int nx,int ny)
{
char s[100];
int tx,ty,w,h;
uRect r;
	sprintf(s,"(%4d,%4d)",nx,ny);
	w = get_text_width(win,s);
	h = get_char_height(win,'A');
	tx = TOP_X + 15;
	ty = TOP_Y + 35 + h;
	set_rect(&r,TOP_X + 15,TOP_Y + 35,w,h);
	erase_rect(win,&r);
	//XSetFunction(sDisp,win->gc,GXcopy);
	//XSetPlaneMask(sDisp,win->gc,0xffffffff);
	XDrawString(sDisp,win->win,win->gc,tx,ty,s,strlen(s));
}
void draw_line(uWindowPtr win,int nx,int ny,int init)
{
static int sx,sy;
static int first = true;
	if( init )
	{
		first = true;
		return;
	}
	if( first )
	{
		first = false;
		sx = nx;
		sy = ny;
		return;
	}
	//printf("(%d,%d) -> (%d,%d) \n",sx,sy,nx,ny);
	XDrawLine(sDisp,win->win,win->gc,sx,sy,nx,ny);
	sx = nx;
	sy = ny;
}

